CREATE OR REPLACE TRIGGER DTULTATU_TABEVENDGER
BEFORE INSERT OR UPDATE OR DELETE
ON TABEVENDGER FOR EACH ROW
DECLARE
   V_CDTABEPREC VARCHAR2(03);
   V_DTINIVGPREC VARCHAR2(10);
   V_COUNT NUMBER;
   V_DSCHAVE VARCHAR2(100);
BEGIN
   IF INSERTING OR UPDATING THEN
      V_CDTABEPREC := NVL(:NEW.CDTABEPREC, :OLD.CDTABEPREC);
      V_DTINIVGPREC := TO_CHAR(NVL(:NEW.DTINIVGPREC, :OLD.DTINIVGPREC), 'DD/MM/YYYY');
      V_DSCHAVE := V_CDTABEPREC||'|'||V_DTINIVGPREC;
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM CTRLATUALTAB
          WHERE NMTABELA = 'TABEVENDGER'
            AND DSCHAVE = V_DSCHAVE;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         INSERT INTO CTRLATUALTAB
            (NMTABELA, DSCHAVE, DTULTATU)
         VALUES
            ('TABEVENDGER', V_DSCHAVE, SYSDATE);
      ELSE
         UPDATE CTRLATUALTAB
            SET DTULTATU = SYSDATE
          WHERE NMTABELA = 'TABEVENDGER'
            AND DSCHAVE = V_DSCHAVE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TABEVENDGER', NULL, 'CDTABEPREC='||:OLD.CDTABEPREC||';DTINIVGPREC='||TO_CHAR(:OLD.DTINIVGPREC,'YYYY-MM-DD HH24:MI:SS')||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TABEVENDGER MODIFY DTULTATU DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TABEVENDGER','6.35.041'); END;
/

